// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from aruco_interfaces:msg/ArucoMarkerPose.idl
// generated code does not contain a copyright notice

#ifndef ARUCO_INTERFACES__MSG__DETAIL__ARUCO_MARKER_POSE__FUNCTIONS_H_
#define ARUCO_INTERFACES__MSG__DETAIL__ARUCO_MARKER_POSE__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "aruco_interfaces/msg/rosidl_generator_c__visibility_control.h"

#include "aruco_interfaces/msg/detail/aruco_marker_pose__struct.h"

/// Initialize msg/ArucoMarkerPose message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * aruco_interfaces__msg__ArucoMarkerPose
 * )) before or use
 * aruco_interfaces__msg__ArucoMarkerPose__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_aruco_interfaces
bool
aruco_interfaces__msg__ArucoMarkerPose__init(aruco_interfaces__msg__ArucoMarkerPose * msg);

/// Finalize msg/ArucoMarkerPose message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_aruco_interfaces
void
aruco_interfaces__msg__ArucoMarkerPose__fini(aruco_interfaces__msg__ArucoMarkerPose * msg);

/// Create msg/ArucoMarkerPose message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * aruco_interfaces__msg__ArucoMarkerPose__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_aruco_interfaces
aruco_interfaces__msg__ArucoMarkerPose *
aruco_interfaces__msg__ArucoMarkerPose__create();

/// Destroy msg/ArucoMarkerPose message.
/**
 * It calls
 * aruco_interfaces__msg__ArucoMarkerPose__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_aruco_interfaces
void
aruco_interfaces__msg__ArucoMarkerPose__destroy(aruco_interfaces__msg__ArucoMarkerPose * msg);


/// Initialize array of msg/ArucoMarkerPose messages.
/**
 * It allocates the memory for the number of elements and calls
 * aruco_interfaces__msg__ArucoMarkerPose__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_aruco_interfaces
bool
aruco_interfaces__msg__ArucoMarkerPose__Sequence__init(aruco_interfaces__msg__ArucoMarkerPose__Sequence * array, size_t size);

/// Finalize array of msg/ArucoMarkerPose messages.
/**
 * It calls
 * aruco_interfaces__msg__ArucoMarkerPose__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_aruco_interfaces
void
aruco_interfaces__msg__ArucoMarkerPose__Sequence__fini(aruco_interfaces__msg__ArucoMarkerPose__Sequence * array);

/// Create array of msg/ArucoMarkerPose messages.
/**
 * It allocates the memory for the array and calls
 * aruco_interfaces__msg__ArucoMarkerPose__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_aruco_interfaces
aruco_interfaces__msg__ArucoMarkerPose__Sequence *
aruco_interfaces__msg__ArucoMarkerPose__Sequence__create(size_t size);

/// Destroy array of msg/ArucoMarkerPose messages.
/**
 * It calls
 * aruco_interfaces__msg__ArucoMarkerPose__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_aruco_interfaces
void
aruco_interfaces__msg__ArucoMarkerPose__Sequence__destroy(aruco_interfaces__msg__ArucoMarkerPose__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // ARUCO_INTERFACES__MSG__DETAIL__ARUCO_MARKER_POSE__FUNCTIONS_H_
